<?php
/**
 * $Id:         comcobalt.php 1.0.0 2013-05-03 18:14:02 Alexander Polyakov $
 * @package          Cobalt
 * @subpackage       Cobalt
 * @version          1.0.0
 * @description
 * @copyright        Copyright © 2013 - All rights reserved.
 * @license          GNU General Public License v2.0
 * @author           Alexander Polyakov
 * @author           mail    alx.polyakov@gmail.com
 * @website          http://alx-polyakov.ru/
 *
 * CODE GENERATED BY: ALEXEY GORDEYEV IK CODE GENERATOR
 * HTTP://WWW.AGJOOMLA.COM/
 *
 */

// no direct access
defined('_JEXEC') or die ('Restricted access');

jimport('joomla.plugin.plugin');
include_once JPATH_ROOT . '/components/com_cobalt/api.php';

/**
 * Example System Plugin
 *
 * @package    Cobalt
 * @subpackage Cobalt
 * @class plgxmapComcobalt
 * @since      1.6.0
 */
class xmap_com_cobalt
{
	public static function prepareMenuItem($node, &$params)
	{
		$link_query = parse_url($node->link);

		if(!isset($link_query['query']))
		{
			return;
		}

		parse_str(html_entity_decode($link_query['query']), $link_vars);

		$view = JArrayHelper::getValue($link_vars, 'view', '');

		$params['add_images'] = JArrayHelper::getValue($params, 'add_images', 0);

		switch($view)
		{
			// index.php?option=com_cobalt&view=records&section_id=2&Itemid=207
			case 'records':
				$section_id = JArrayHelper::getValue($link_vars, 'section_id', 0);
				$node->uid  = 'com_cobalts' . $section_id;
				break;

			// index.php?option=com_cobalt&view=elements&layout=buyer&Itemid=484
			case 'elements':
				$layout           = JArrayHelper::getValue($link_vars, 'layout', 0);
				$node->uid        = 'com_cobalt' . $layout;
				$node->expandible = FALSE;
				break;

			//index.php?option=com_cobalt&view=form&type_id=0&section_id=0&Itemid=488
			case 'form':
				$section_id       = JArrayHelper::getValue($link_vars, 'section_id', 0);
				$node->uid        = 'com_cobaltf' . $section_id;
				$node->expandible = FALSE;
				break;

			// index.php?option=com_cobalt&view=moderators&Itemid=490
			case 'moderators':
				$node->uid        = 'com_cobaltm';
				$node->expandible = FALSE;
				break;

			// index.php?option=com_cobalt&view=notifications&Itemid=492
			case 'notifications':
				$node->uid        = 'com_cobaltn';
				$node->expandible = FALSE;
				break;

			// index.php?option=com_cobalt&view=record&id=1&Itemid=494
			case 'record':
				$id               = JArrayHelper::getValue($link_vars, 'id', 0);
				$record           = ItemsStore::getRecord($id);
				$node->modified   = $record->mtime;
				$node->uid        = 'com_cobaltr' . $id;
				$node->expandible = FALSE;
				break;
		}
	}

	public static function getTree($xmap, $parent, &$params)
	{

		$db     = JFactory::getDBO();
		$app    = JFactory::getApplication();
		$user   = JFactory::getUser();
		$result = NULL;

		$link_query = parse_url($parent->link);
		if(!isset($link_query['query']))
		{
			return;
		}

		parse_str(html_entity_decode($link_query['query']), $link_vars);
		$view = JArrayHelper::getValue($link_vars, 'view', '');

		$expand_sections = JArrayHelper::getValue($params, 'expand_sections', 0);

		$expand_sections           = ($expand_sections == 1
			|| ($expand_sections == 2 && $xmap->view == 'xml')
			|| ($expand_sections == 3 && $xmap->view == 'html')
			|| $xmap->view == 'navigator');
		$params['expand_sections'] = $expand_sections;

		$show_unauth           = JArrayHelper::getValue($params, 'show_unauth', 1);
		$show_unauth           = ($show_unauth == 1
			|| ($show_unauth == 2 && $xmap->view == 'xml')
			|| ($show_unauth == 3 && $xmap->view == 'html'));
		$params['show_unauth'] = $show_unauth;

		$priority   = JArrayHelper::getValue($params, 'cat_priority', $parent->priority);
		$changefreq = JArrayHelper::getValue($params, 'cat_changefreq', $parent->changefreq);
		if($priority == '-1')
		{
			$priority = $parent->priority;
		}
		if($changefreq == '-1')
		{
			$changefreq = $parent->changefreq;
		}

		$params['cat_priority']   = $priority;
		$params['cat_changefreq'] = $changefreq;

		$priority   = JArrayHelper::getValue($params, 'art_priority', $parent->priority);
		$changefreq = JArrayHelper::getValue($params, 'art_changefreq', $parent->changefreq);
		if($priority == '-1')
		{
			$priority = $parent->priority;
		}
		if($changefreq == '-1')
		{
			$changefreq = $parent->changefreq;
		}

		$params['art_priority']   = $priority;
		$params['art_changefreq'] = $changefreq;

		$params['max_art']     = intval(JArrayHelper::getValue($params, 'max_art', 0));
		$params['max_art_age'] = intval(JArrayHelper::getValue($params, 'max_art_age', 0));

		$params['nullDate'] = $db->Quote($db->getNullDate());

		$params['nowDate'] = $db->Quote(JFactory::getDate()->toSql());
		$params['groups']  = implode(',', $user->getAuthorisedViewLevels());

		// TODO: Check getLanguageFilter() because it is not found.
		$params['language_filter'] = $app->getLanguageFilter();

		switch($view)
		{
			case 'records':
				$section_id = JArrayHelper::getValue($link_vars, 'section_id', 0);
				if($params['expand_sections'] && $section_id)
				{
					$section = ItemsStore::getSection($section_id);
					$params  = new JRegistry($params);
					self::expandSection($xmap, $parent, $section, $params);
				}
				break;
		}
	}

	/**
	 * @param $xmap    Object
	 * @param $parent  Object
	 * @param $section Object
	 * @param $params  JRegistry
	 */
	private static function expandSection($xmap, $parent, $section, $params)
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(TRUE);

		$query->select('a.id, a.title, a.alias, a.access, a.created_time as created, a.modified_time as modified, a.params');
		$query->from(' #__js_res_categories AS a');
		$query->where('a.section_id = ' . $section->id);
		$query->where('a.parent_id=1');
		$query->where('a.published = 1 ');

		if($params->get('language_filter', 0))
		{
			$query->where('a.language in (' . $db->quote(JFactory::getLanguage()->getTag()) . ',' . $db->quote('*') . ')');
		}

		if(!$params->get('show_unauth', 0))
		{
			$query->where('a.access IN (' . $params->get('groups', 0) . ') ');
		}

		if($xmap->view != 'xml')
		{
			$query->order('a.lft ');
		}

		$db->setQuery($query);
		$items = $db->loadObjectList();

		if(empty($items))
		{
			return;
		}

		$xmap->changeLevel(1);

		foreach($items as $item)
		{
			$item->params = new JRegistry($item->params);

			$node             = new stdclass();
			$node->id         = $parent->id;
			$node->uid        = $parent->uid . 'c' . $item->id;
			$node->browserNav = $parent->browserNav;
			$node->priority   = $params->get('cat_priority');
			$node->changefreq = $params->get('cat_changefreq');
			$node->name       = $item->title;
			$node->expandible = TRUE;
			$node->secure     = $parent->secure;
			$node->newsItem   = 0;

			// TODO: Should we include category name or metakey here?
			// $node->keywords = $item->metakey;

			// For the google news we should use te publication date
			if($xmap->isNews || !$item->modified)
			{
				$item->modified = $item->created;
			}

			$node->link = Url::records($section, $item);
			$node->link = JRoute::_($node->link, TRUE);

			if($xmap->printNode($node))
			{
				self::expandCategory($xmap, $parent, $section, $item, $params);
			}
		}

		$xmap->changeLevel(-1);
	}

	/**
	 * @param $xmap    Object
	 * @param $parent  Object
	 * @param $section Object
	 * @param $cat     Object
	 * @param $params  JRegistry
	 */
	public static function expandCategory($xmap, $parent, $section, $cat, $params)
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(TRUE);

		$query->select('a.id, a.title, a.alias, a.access, a.path AS route, a.created_time created, a.modified_time modified, a.params');
		$query->from('#__js_res_categories AS a');
		$query->where('a.section_id = ' . $section->id);
		$query->where('a.parent_id=' . $cat->id);
		$query->where('a.published = 1');

		if($params->get('language_filter', 0))
		{
			$query->where('a.language IN (' . $db->quote(JFactory::getLanguage()->getTag()) . ',' . $db->quote('*') . ')');
		}

		if(!$params->get('show_unauth'))
		{
			$query->where('a.access IN (' . $params->get('groups', 0) . ') ');
		}

		$query->order($xmap->view != 'xml' ? "a.lft" : '');

		$db->setQuery($query);
		$items = $db->loadObjectList();

		$expand_records = $expand_records_type = intval($params->get('expand_records', 0));

		if($expand_records_type == 1 && $expand_records)
		{
			self::includeCategoryContent($xmap, $parent, $cat, $params, $section);
		}

		if(!empty($items))
		{
			$xmap->changeLevel(1);

			foreach($items as $item)
			{
				$item->params = new JRegistry($item->params);

				$node             = new stdclass();
				$node->id         = $parent->id;
				$node->uid        = $parent->uid . 'c' . $item->id;
				$node->browserNav = $parent->browserNav;
				$node->priority   = $params->get('cat_priority');
				$node->changefreq = $params->get('cat_changefreq');
				$node->name       = $item->title;
				$node->expandible = TRUE;
				$node->secure     = $parent->secure;
				$node->newsItem   = 0;

				// TODO: Should we include category name or metakey here?
				// $node->keywords = $item->metakey;

				// For the google news we should use te publication date instead
				if($xmap->isNews || !$item->modified)
				{
					$item->modified = $item->created;
				}

				$node->link = Url::records($section, $item);
				$node->link = JRoute::_($node->link, TRUE);

				if($xmap->printNode($node))
				{
					self::expandCategory($xmap, $parent, $section, $item, $params);
				}
			}

			$xmap->changeLevel(-1);
		}

		if($expand_records_type == 0 && $expand_records)
		{
			self::includeCategoryContent($xmap, $parent, $cat, $params, $section);
		}
	}

	/**
	 * @param $xmap
	 * @param $parent
	 * @param $cat
	 * @param $params JRegistry
	 * @param $section
	 */
	private static function includeCategoryContent($xmap, $parent, $cat, $params, $section)
	{

		$db    = JFactory::getDbo();
		$query = $db->getQuery(TRUE);

		$query->select('a.id, a.title, a.alias, a.type_id, a.user_id, a.ctime as created, a.mtime as modified, a.langs');
		$query->from('#__js_res_record as a');
		$query->where('a.published = 1');

		if($params->get('max_art_age') || $xmap->isNews)
		{
			$days = (($xmap->isNews && ($params->get('max_art_age', 0) > 3 || !$params->get('max_art_age'))) ? 3 : $params->get('max_art_age'));
			$query->where(" a.ctime >= '" . date('Y-m-d H:i:s', time() - $days * 86400) . "'");
		}

		if($params->get('language_filter'))
		{
			$query->where('a.langs in (' . $db->quote(JFactory::getLanguage()->getTag()) . ',' . $db->quote('*'));
		}

		if(!$params->get('show_unauth'))
		{
			$query->where('a.access IN (' . $params->get('groups', 0) . ') ');
		}

		$articles_order = $params->get('articles_order', 'modified');
		if($articles_order != 'a.title asc')
		{
			$query->order($articles_order . " DESC ");
		}
		else
		{
			$query->order('a.title asc');
		}


		$max_art = $params->get('max_art', 0);
		if($max_art)
		{
			$db->setQuery($query, 0, $max_art);
		}
		else
		{
			$db->setQuery($query);
		}

		$items = $db->loadObjectList();

		if(empty($items))
		{
			return;
		}
		$xmap->changeLevel(1);

		foreach($items as $item)
		{
			$node             = new stdclass();
			$node->id         = $parent->id;
			$node->uid        = $parent->uid . 'a' . $item->id;
			$node->browserNav = $parent->browserNav;
			$node->priority   = $params->get('art_priority');
			$node->changefreq = $params->get('art_changefreq');
			$node->name       = $item->title;
			$node->modified   = $item->modified;
			$node->expandible = FALSE;
			$node->secure     = $parent->secure;
			$node->newsItem = 1;
			$node->language = $item->langs;

			// TODO: Should we include category name or metakey here?
			// $node->keywords = $item->metakey;

			// For the google news we should use te publication date instead
			if($xmap->isNews || !$node->modified)
			{
				$node->modified = $item->created;
			}

			$node->link = JRoute::_(Url::record($item, NULL, $section, $cat));
			$xmap->printNode($node);
		}

		$xmap->changeLevel(-1);
	}
}